/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2022  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////


#ifndef ACCELERATIONCALCULATORHEADERFILE
#define ACCELERATIONCALCULATORHEADERFILE

#include <QMainWindow>

class QLabel;
class QLineEdit;
class QTimer;
class QResizeEvent;
class QGridLayout;
class QWidget;

class TAccelerationCalculator : public QMainWindow
{
Q_OBJECT

public:

// CREATORS
	TAccelerationCalculator(const QWidget *parent=0, Qt::WindowFlags flags=Qt::WindowFlags());
	virtual ~TAccelerationCalculator(void);

// ACCESSORS

// MANIPULATORS

signals:

private slots:
	void Screen_Orientation_Changed(Qt::ScreenOrientation);
	void Input_Text_Changed(void);
	void Update_Fields(void);
	
protected:
	virtual void resizeEvent(QResizeEvent *event);

private:
	
enum TDisplayMode
{
	DISPLAY_WIDE = 0,
	DISPLAY_TALL
};
	QGridLayout							*d_control_layout;
	QGridLayout							*d_central_widget_layout;

    QWidget								*d_central_widget;
    QLabel								*d_graph_label;
	QLabel								*d_copyright_label;
	QLineEdit							*d_acceleration_edit;
	QLineEdit							*d_final_velocity_edit;
	QLineEdit							*d_initial_velocity_edit;
	QLineEdit							*d_transition_time_edit;
	QLineEdit							*d_transition_distance_edit;
	QTimer								*d_update_timer;
	
	QString								d_display_graph_name;
	TDisplayMode						d_display_mode;

	
	void Update_Layout(void);
	void Update_Graph(const QSize &widget_size);

// NOT IMPLEMENTED
	TAccelerationCalculator(const TAccelerationCalculator&);
	TAccelerationCalculator& operator=(const TAccelerationCalculator&);
};

#endif
